routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\SelectController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\Auth\LoginController;
use App\Http\Controllers\Auth\LogoutController;
use App\Http\Controllers\Employer\JobController;
use App\Http\Controllers\Auth\RegisterController;


Route::group(['middleware'=>"web"], function(){
    //employer routes
    Route::get('/', [HomeController::class, 'index'])->name('home');
 
    Route::get('login', [LoginController::class, 'index'])->name('login');
    Route::post('login', [LoginController::class, 'store']);

    Route::post('logout', [LogoutController::class, 'store'])->name('logout');

    Route::get('registerCandidate', [RegisterController::class, 'index']);

    Route::get('register', [RegisterController::class, 'index'])->name('register');
    Route::post('register', [RegisterController::class, 'store']);

    Route::get('dashboard', [DashboardController::class, 'index'])->name('dashboard');
    
    Route::post('postJobs', [JobController::class, 'store']);
    Route::get('postJobs', [JobController::class, 'index'])->name('postJobs');
    Route::get('/jobs/search', [JobController::class, 'search'])->name('jobs.search');

    Route::get('deleteJob/{id}',[JobController::class, 'deleteJob']);
    Route::get('editJob/{id}', [JobController::class, 'editJob']);

    Route::post('editJob', [JobController::class, 'updateJob'])->name('editJob');

});
    //candidate routes
    Route::post('registerCandidate', [RegisterController::class, 'storeCandidate'])->name('registerCandidate');

    Route::get('registerCandidate', [RegisterController::class, 'index']);  

    Route::get('loginCandidate', [LoginController::class, 'index'])->name('loginCandidate');
    Route::post('loginCandidate', [LoginController::class, 'storeCandidate']);

    Route::get('selectRegister', [SelectController::class, 'index'])->name('selectRegister');
    Route::get('selectLogin', [SelectController::class, 'index'])->name('selectLogin');

    Route::post('applyJob', [JobController::class, 'applyJob'])->name('applyJob');
    Route::delete('unapplyJob', [JobController::class, 'unapplyJob'])->name('unapplyJob');

    Route::post('logoutCandidate', [LogoutController::class, 'storeCandidate'])->name('logoutCandidate');

    Route::get('myJobs', [JobController::class, 'displayJobs']);

app/Models/Employer.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\Authenticatable;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Notifications\Notifiable;


class Employer extends Model implements Authenticatable
{
    use HasFactory;
    use Notifiable;

    protected $guard = 'employer';
    protected $table = 'employers';

    protected $fillable = [
        'company_name',
        'company_address',
        'first_name',
        'last_name',
        'gender',
        'contact',
        'location',
        'email',
        'password'
    ];

    
    protected $hidden = [
        'password',
        'remember_token',
    ];

    
    protected $casts = [
        'email_verified_at' => 'datetime',
        'password' => 'hashed',
    ];

    public function jobs()
    {
        return $this->hasMany(Job::class);
    }

    public function getAuthIdentifierName()
    {
        return 'id';
    }

    public function getAuthIdentifier()
    {
        return $this->getKey();
    }
    public function getAuthPassword()
    {
        return $this->password;
    }

    public function getRememberToken()
    {
        return $this->remember_token;
    }

    public function setRememberToken($value)
    {
        $this->remember_token = $value;
    }

    public function getRememberTokenName()
    {
        return 'remember_token';
    }
}

app/Http/Controllers/Employer/JobController.php
<?php

namespace App\Http\Controllers\Employer;

use App\Models\Job;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Candidate;

class JobController extends Controller
{
    public function index()
    {
        return view('employer.postJobs');
    }


    public function store(Request $request)
    {
        $this->validate($request, [
            "job_title" => "required|max:255",
            "description" => "required",
            "budget" => "required|numeric",
            "job_type" => "required",
            "job_location" => "required",
            "experience_required" => "required|numeric",
        ]);

        Job::Create([
            "job_title" => $request->job_title,
            "description" => $request->description,
            "budget" => $request->budget,
            "job_type" => $request->job_type,
            "job_location" => $request->job_location,
            "experience_required" => $request->experience_required,
            "employer_id" => auth()->guard('employer')->user()->id,
        ]);
        
        return redirect()->route('dashboard');
    }


    public function search(Request $request)
    {
        $query = $request->input('query');
        $pagination = config('app.pagination.default');

        $jobs = Job::with('employer')
        ->where('job_title', 'LIKE', '%'.$query.'%')
        ->orWhere('job_location', 'LIKE', '%'.$query.'%')
        ->orWhereHas('employer', function ($employerQuery) use ($query) {
            $employerQuery->where('company_name', 'LIKE', '%' . $query . '%');
        })
        ->orderBy('created_at', 'desc')
        ->paginate($pagination);

        return view('home', [
            'jobs' => $jobs,
        ]);
    }


    public function applyJob(Request $request)
    {
        $candidate = Candidate::find(auth()->guard('candidate')->user()->id);
        $job = $request->job_id;

        $candidate->jobs()->attach($job);

        return redirect()->route('home');
    }


    public function unapplyJob(Request $request)
    {
        $candidate = Candidate::find(auth()->guard('candidate')->user()->id);
        $job = $request->job_id;

        $candidate->jobs()->detach($job);

        return redirect()->route('home');
    }


    public function displayJobs()
    {
        $employerId = auth()->guard('employer')->id();

        $jobs = Job::withCount('candidate')
            ->where('employer_id', $employerId)
            ->orderBy('created_at', 'desc')
            ->get();

        return view('employer.myJobs', [
            'jobs' => $jobs,
        ]);
    }


    public function deleteJob($id)
    {
        $job = Job::find($id);
        $job->delete();
        return redirect('myJobs');

    }


    public function editJob($id)
    {
        $job = Job::find($id);
        return view('employer.editJob',['job'=> $job]);
    }

    public function updateJob(Request $request)
    {

        $this->validate($request, [
            "job_title" => "required|max:255",
            "description" => "required",
            "budget" => "required|numeric",
            "job_type" => "required",
            "job_location" => "required",
            "experience_required" => "required|numeric",
        ]);
    
        $job = Job::findOrFail($request->id);
    
        $job->update([
            "job_title" => $request->job_title,
            "description" => $request->description,
            "budget" => $request->budget,
            "job_type" => $request->job_type,
            "job_location" => $request->job_location,
            "experience_required" => $request->experience_required,
        ]);
    
        return redirect()->route('employer.myJobs');
    }

}

resources/views/employer/editJob.blade.php
@extends('layouts.app')

@section('content')
<div class="flex justify-center">
    <div class="w-4/12 bg-white p-6 rounded-lg">
        <h1 class="mb-4 pl-4 text-2xl font-bold">Edit Job</h1>
        <form action="{{ route('editJob') }}" method="post">
            @csrf
            @error('job_title')
                <div class="text-red-500 mb-2 pl-4 text-sm">
                    {{ $message }}
                </div>
            @enderror
            <div class="mb-4">
                <label for="job_title" class="sr-only">Job Title</label>
                <input type="text" name="job_title" id="job_title" placeholder="Job Title" value="{{ $job->job_title }}"
                class="bg-gray-100 border-2 w-full p-4 rounded-lg @error('job_title') border-red-500 @enderror">
            </div>

            @error('description')
                <div class="text-red-500 mb-2 pl-4 text-sm">
                    {{ $message }}
                </div>
            @enderror
            <div class="mb-4">
                <label for="description" class="sr-only">Job Description</label>
                <textarea name="description" id="description" cols="30" rows="3"
                class="bg-gray-100 border-2 w-full p-4 rounded-lg @error('description') border-red-500 @enderror"
                placeholder="Job Description">{{ $job->description }}</textarea>
            </div>

            @error('budget')
                <div class="text-red-500 mb-2 pl-4 text-sm">
                    {{ $message }}
                </div>
            @enderror
            <div>
                <label for="budget" class="sr-only">Budget</label>
                <input type="text" name="budget" id="budget" placeholder="Budget( in lakhs )" value="{{ $job->budget }}"
                class="bg-gray-100 border-2 w-full p-4 rounded-lg @error('budget') border-red-500 @enderror">
            </div>


            @error('job_type')
            <div class="text-red-500 mb-2 pl-4 text-sm">
                {{ $message }}
            </div>
            @enderror
            <div class="mb-4">   
                <label for="job_type" class="pl-4 text-gray-500 sr-only">Job Type</label><br>
                <select name="job_type" id="job_type" class="bg-gray-100 border-2 w-full p-4 rounded-lg text-gray-500
                @error('job_type') border-red-500 @enderror">
                    <option value="{{ $job->job_type }}" selected="selected">{{ $job->job_type }}</option>
                    <option value="full">Full Time</option>
                    <option value="part">Part Time</option>
                </select
            </div>

            @error('job_location')
            <div class="text-red-500 mb-2 pl-4 text-sm">
                {{ $message }}
            </div>
            @enderror
            <div class="mb-4">   
                <label for="cars" class="pl-4 text-gray-500 sr-only">Job Location</label><br>

                <select name="job_location" id="job_location" class="bg-gray-100 border-2 w-full p-4 rounded-lg text-gray-500
                @error('job_location') border-red-500 @enderror">
                    <option value="{{ $job->job_location }}" selected="selected">{{ $job->job_location }}</option>
                    <option value="mumbai">Mumbai</option>
                    <option value="pune">Pune</option>
                    <option value="bangalore">Bangalore</option>
                    <option value="delhi">Delhi</option>
                </select
            </div>

            @error('experience_required')
            <div class="text-red-500 mb-2 pl-4 text-sm">
                {{ $message }}
            </div>
            @enderror
            <div class="mb-4">   
                <label for="experience_required" class="pl-4 text-gray-500 sr-only">Experience Required</label><br>
                <input type="text" name="experience_required" id="experience_required" placeholder="Experience in Years" value="{{ $job->experience_required }}"
                class="bg-gray-100 border-2 w-full p-4 rounded-lg @error('experience_required') border-red-500 @enderror">
            </div>

            
            
            <div class="mt-6">
                <button type="submit" class="bg-sky-500 text-white py-3 rounded font-medium w-full">Update Job</button>
            </div>
        </form>
    </div>
</div>
@endsection

resources/views/employer/myJobs.blade.php
@extends('layouts.app')

@section('content')
    <div class="flex justify-center">
        <div class="w-6/12 bg-white p-6 rounded-lg">
            <h1 class="mb-4 pl-4 text-2xl font-bold">My Jobs</h1>

@if($jobs->count())
<div class="relative overflow-x-auto shadow-md sm:rounded-lg">
    <table class="w-full text-sm text-left text-gray-500 ">
        <thead class="text-xs text-gray-700 uppercase bg-gray-50 ">
            <tr>
                <th scope="col" class="px-6 py-3">
                    Job Title
                </th>
                <th scope="col" class="px-6 py-3">
                    Job Location
                </th>
                <th scope="col" class="px-6 py-3">
                    Max CTC Budget
                </th>
                <th scope="col" class="px-6 py-3">
                    Applications
                </th>
                <th scope="col" class="px-6 py-3">
                    Actions
                </th>
            </tr>
        </thead>
        <tbody>
            @foreach ($jobs as $job)
                <tr class="bg-white border-b ">
                    <th scope="row" class="px-6 py-4 font-medium text-gray-900 whitespace-nowrap ">
                        {{ $job->job_title }}
                    </th>
                    <td class="px-6 py-4 text-center">
                        {{ $job->job_location }}
                    </td>
                    <td class="px-6 py-4 text-center">
                        {{ $job->budget }}
                    </td>
                    <td class="px-6 py-4 text-center">
                        {{ $job->candidate_count }}
                    </td>
                    <td class="px-6 py-4 text-center">
                        <a href="{{ "editJob/".$job->id}}" class="font-medium text-blue-600  hover:underline">Edit</a> | 
                        <a href="{{ "deleteJob/".$job->id }}" class="font-medium text-blue-600  hover:underline">Delete</a>
                    </td>
                </tr> 
            @endforeach
        </tbody>
        @else
            <div class="mb4 font-bold">Sorry, it seems you've not posted any jobs yet</div>
        @endif
    </table>
</div>

          
    </div>
@endsection

resources/views/employer/postJobs.blade.php
@extends('layouts.app')

@section('content')
<div class="flex justify-center">
    <div class="w-4/12 bg-white p-6 rounded-lg">
        <h1 class="mb-4 pl-4 text-2xl font-bold">Post A Job</h1>
        <form action="{{ route('postJobs') }}" method="post">
            @csrf
            @error('job_title')
                <div class="text-red-500 mb-2 pl-4 text-sm">
                    {{ $message }}
                </div>
            @enderror
            <div class="mb-4">
                <label for="job_title" class="sr-only">Job Title</label>
                <input type="text" name="job_title" id="job_title" placeholder="Job Title" value="{{ old('job_title')}}"
                class="bg-gray-100 border-2 w-full p-4 rounded-lg @error('job_title') border-red-500 @enderror">
            </div>

            @error('description')
                <div class="text-red-500 mb-2 pl-4 text-sm">
                    {{ $message }}
                </div>
            @enderror
            <div class="mb-4">
                <label for="description" class="sr-only">Job Description</label>
                <textarea name="description" id="description" cols="30" rows="3"
                class="bg-gray-100 border-2 w-full p-4 rounded-lg @error('description') border-red-500 @enderror"
                placeholder="Job Description">{{ old('description')}}</textarea>
            </div>

            @error('budget')
                <div class="text-red-500 mb-2 pl-4 text-sm">
                    {{ $message }}
                </div>
            @enderror
            <div>
                <label for="budget" class="sr-only">Budget</label>
                <input type="text" name="budget" id="budget" placeholder="Budget( in lakhs )" value="{{ old('budget') }}"
                class="bg-gray-100 border-2 w-full p-4 rounded-lg @error('budget') border-red-500 @enderror">
            </div>


            @error('job_type')
            <div class="text-red-500 mb-2 pl-4 text-sm">
                {{ $message }}
            </div>
            @enderror
            <div class="mb-4">   
                <label for="job_type" class="pl-4 text-gray-500 sr-only">Job Type</label><br>
                <select name="job_type" id="job_type" class="bg-gray-100 border-2 w-full p-4 rounded-lg text-gray-500
                @error('job_type') border-red-500 @enderror">
                    <option disabled selected value>Select Job Type</option>
                    <option value="full">Full Time</option>
                    <option value="part">Part Time</option>
                </select
            </div>

            @error('job_location')
            <div class="text-red-500 mb-2 pl-4 text-sm">
                {{ $message }}
            </div>
            @enderror
            <div class="mb-4">   
                <label for="cars" class="pl-4 text-gray-500 sr-only">Job Location</label><br>

                <select name="job_location" id="job_location" class="bg-gray-100 border-2 w-full p-4 rounded-lg text-gray-500
                @error('job_location') border-red-500 @enderror">
                    <option disabled selected value>Select Job Location</option>
                    <option value="mumbai">Mumbai</option>
                    <option value="pune">Pune</option>
                    <option value="bangalore">Bangalore</option>
                    <option value="delhi">Delhi</option>
                </select
            </div>

            @error('experience_required')
            <div class="text-red-500 mb-2 pl-4 text-sm">
                {{ $message }}
            </div>
            @enderror
            <div class="mb-4">   
                <label for="experience_required" class="pl-4 text-gray-500 sr-only">Experience Required</label><br>
                <input type="text" name="experience_required" id="experience_required" placeholder="Experience in Years" value="{{ old('experience_required') }}"
                class="bg-gray-100 border-2 w-full p-4 rounded-lg @error('experience_required') border-red-500 @enderror">
            </div>

            
            
            <div class="mt-6">
                <button type="submit" class="bg-sky-500 text-white py-3 rounded font-medium w-full">Post</button>
            </div>
        </form>
    </div>
</div>
@endsection